## hisat2 2.0.4

=== debian/changelog ===
hisat2 (2.0.4-2) unstable; urgency=medium

  * Team upload.
  * Fix Vcs-Git.
  * Fix build on kFreeBSD. Thanks to Steven Chamberlain for the patch.
    Closes: #834864
  * Make build reproducible.
    - Set C(XX,PP)FLAGS to make sure -fdebug-prefix-map is set.
    - Set TZ=UTC.
  * Remove arch-restrictive compiler flags.
    Closes: #834862

 -- Sascha Steinbiss <satta@debian.org>  Thu, 25 Aug 2016 15:46:42 +0000

hisat2 (2.0.4-1) unstable; urgency=medium

  * Initial release. (Closes: #834592)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 17 Aug 2016 05:15:40 -0700
