=== debian/watch ===
version=3
opts=pasv \
      ftp://ftp.ccb.jhu.edu/pub/infphilo/hisat2/downloads/hisat2-([0-9.]+)-source.zip
