## hisat2 2.0.5

=== debian/changelog ===
hisat2 (2.0.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Architecture: amd64 kfreebsd-amd64
    Closes: #834862, #834863
  * d/watch:
     - version=4
     - xz compression
  * debhelper 10

 -- Andreas Tille <tille@debian.org>  Fri, 09 Dec 2016 13:45:26 +0100
