=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                help2man,
                pandoc,
                python
@@ -13,7 +13,7 @@
 Homepage: https://ccb.jhu.edu/software/hisat2/index.shtml
 
 Package: hisat2
-Architecture: any
+Architecture: amd64 kfreebsd-amd64
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}, python
 Description: graph-based alignment of short nucleotide reads to many genomes
  HISAT2 is a fast and sensitive alignment program for mapping next-generation
