## hisat2 2.1.0

=== Makefile ===
--- 
+++ 
@@ -186,6 +186,8 @@
 GENERAL_LIST = $(wildcard scripts/*.sh) \
 	$(wildcard scripts/*.pl) \
 	$(wildcard *.py) \
+	$(wildcard hisatgenotype_modules/*.py) \
+	$(wildcard hisatgenotype_scripts/*.py) \
 	doc/manual.inc.html \
 	doc/README \
 	doc/style.css \
