=== debian/changelog ===
hisat2 (2.1.0-2nopython3hisat3) unstable; urgency=medium

  * armhf armel ppc64el s390x: add -Wno-narrowing

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 04 Jan 2020 22:52:02 +0100

hisat2 (2.1.0-2nopython3hisat2) unstable; urgency=medium

  [ Saira Hussain ]
  * Add autopkgtest

  [ Andreas Tille ]
  * Install hisat2_extract_splice_sites.py
  * Recommends: bcftools, samtools

  [ Michael R. Crusoe ]
  * Skip the new python3-hisat2 package while we wait for 2.1.0-3 to go
    through the NEW queue.
  * Include SIMD everywhere headers and enable building on all architectures.
  * debhelper-compat 12
  * Remove trailing whitespace in debian/control
  * Ported Python scripts to Python 3 using 2to3. Closes: #943125

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 30 Dec 2019 20:08:00 +0100

hisat2 (2.1.0-2) unstable; urgency=medium

  * Team upload.
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1
  * Fix wrong path for Perl interpreter
  * Do not parse d/changelog

 -- Andreas Tille <tille@debian.org>  Mon, 24 Sep 2018 11:52:06 +0200

hisat2 (2.1.0-1) unstable; urgency=medium

  * Team upload

  [ Steffen Moeller ]
  * debian/upstream/metadata: Added ref to OMICtools

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.1.0 (no changes needed)

 -- Andreas Tille <tille@debian.org>  Mon, 04 Sep 2017 14:49:40 +0200
