=== debian/watch ===
version=4
opts="pasv,repack,compression=xz" \
      ftp://ftp.ccb.jhu.edu/pub/infphilo/hisat2/downloads/hisat2-([0-9.]+)-source.zip

# Download tarball is very strangely named on Github - this will not work
# https://github.com/infphilo/hisat2/releases .*/archive/@ANY_VERSION@@ARCHIVE_EXT@
