## hisat2 2.2.0

=== Makefile ===
--- 
+++ 
@@ -55,8 +55,8 @@
 	MACOS = 1
 endif
 
-EXTRA_FLAGS += -DPOPCNT_CAPABILITY
-INC += -I third_party
+EXTRA_FLAGS += -DPOPCNT_CAPABILITY -std=c++11
+INC += -I. -I third_party 
 
 MM_DEF = 
 
@@ -127,8 +127,27 @@
 
 BUILD_CPPS = diff_sample.cpp
 
+REPEAT_CPPS = \
+	mask.cpp \
+	qual.cpp \
+	aligner_bt.cpp \
+	scoring.cpp \
+	simple_func.cpp \
+	dp_framer.cpp \
+	aligner_result.cpp \
+	aligner_sw_driver.cpp \
+	aligner_sw.cpp \
+	aligner_swsse_ee_i16.cpp \
+	aligner_swsse_ee_u8.cpp \
+	aligner_swsse_loc_i16.cpp \
+	aligner_swsse_loc_u8.cpp \
+	aligner_swsse.cpp \
+	bit_packed_array.cpp \
+	repeat_builder.cpp
+
 HISAT2_CPPS_MAIN = $(SEARCH_CPPS) hisat2_main.cpp
 HISAT2_BUILD_CPPS_MAIN = $(BUILD_CPPS) hisat2_build_main.cpp
+HISAT2_REPEAT_CPPS_MAIN = $(REPEAT_CPPS) $(BUILD_CPPS) hisat2_repeat_main.cpp
 
 SEARCH_FRAGMENTS = $(wildcard search_*_phase*.c)
 VERSION = $(shell cat VERSION)
@@ -155,7 +174,7 @@
 endif
 SSE_FLAG=-msse2
 
-DEBUG_FLAGS    = -O0 -g3 $(BIToS_FLAG) $(SSE_FLAG)
+DEBUG_FLAGS    = -O0 -g3 $(BITS_FLAG) $(SSE_FLAG)
 DEBUG_DEFS     = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(EXTRA_FLAGS)\""
 RELEASE_FLAGS  = -O3 $(BITS_FLAG) $(SSE_FLAG) -funroll-loops -g3
 RELEASE_DEFS   = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(EXTRA_FLAGS)\""
@@ -164,8 +183,9 @@
 
 ifeq (1,$(USE_SRA))
 	ifeq (1, $(MACOS))
-		DEBUG_FLAGS += -mmacosx-version-min=10.6
-		RELEASE_FLAGS += -mmacosx-version-min=10.6
+		SRA_LIB += -stdlib=libc++
+		DEBUG_FLAGS += -mmacosx-version-min=10.10
+		RELEASE_FLAGS += -mmacosx-version-min=10.10
 	endif
 endif
 
@@ -175,22 +195,50 @@
 	hisat2-align-s \
 	hisat2-align-l \
 	hisat2-inspect-s \
-	hisat2-inspect-l
+	hisat2-inspect-l \
+	hisat2-repeat
 HISAT2_BIN_LIST_AUX = hisat2-build-s-debug \
 	hisat2-build-l-debug \
 	hisat2-align-s-debug \
 	hisat2-align-l-debug \
 	hisat2-inspect-s-debug \
-	hisat2-inspect-l-debug
+	hisat2-inspect-l-debug \
+	hisat2-repeat-debug
+
+HT2LIB_DIR = hisat2lib
+HT2LIB_SRCS = $(SHARED_CPPS) \
+			  $(HT2LIB_DIR)/ht2_init.cpp \
+			  $(HT2LIB_DIR)/ht2_repeat.cpp \
+			  $(HT2LIB_DIR)/ht2_index.cpp
+
+HT2LIB_OBJS = $(HT2LIB_SRCS:.cpp=.o)
+
+HT2LIB_DEBUG_OBJS = $(addprefix .ht2lib-obj-debug/,$(HT2LIB_OBJS))
+HT2LIB_RELEASE_OBJS = $(addprefix .ht2lib-obj-release/,$(HT2LIB_OBJS))
+HT2LIB_SHARED_DEBUG_OBJS = $(addprefix .ht2lib-obj-debug-shared/,$(HT2LIB_OBJS))
+HT2LIB_SHARED_RELEASE_OBJS = $(addprefix .ht2lib-obj-release-shared/,$(HT2LIB_OBJS))
+
+HT2LIB_PKG_SRC = \
+	$(HT2LIB_DIR)/ht2_init.cpp \
+	$(HT2LIB_DIR)/ht2_repeat.cpp \
+	$(HT2LIB_DIR)/ht2_index.cpp \
+	$(HT2LIB_DIR)/ht2.h \
+	$(HT2LIB_DIR)/ht2_handle.h \
+	$(HT2LIB_DIR)/java_jni/Makefile \
+	$(HT2LIB_DIR)/java_jni/ht2module.c \
+	$(HT2LIB_DIR)/java_jni/HT2Module.java \
+	$(HT2LIB_DIR)/java_jni/HT2ModuleExample.java \
+	$(HT2LIB_DIR)/pymodule/Makefile \
+	$(HT2LIB_DIR)/pymodule/ht2module.c \
+	$(HT2LIB_DIR)/pymodule/setup.py \
+	$(HT2LIB_DIR)/pymodule/ht2example.py
+
 
 GENERAL_LIST = $(wildcard scripts/*.sh) \
 	$(wildcard scripts/*.pl) \
 	$(wildcard *.py) \
 	$(wildcard hisatgenotype_modules/*.py) \
 	$(wildcard hisatgenotype_scripts/*.py) \
-	doc/manual.inc.html \
-	doc/README \
-	doc/style.css \
 	$(wildcard example/index/*.ht2) \
 	$(wildcard example/reads/*.fa) \
 	example/reference/22_20-21M.fa \
@@ -219,8 +267,9 @@
 	$(wildcard *.hh) \
 	$(wildcard *.c) \
 	$(wildcard *.cpp) \
-	doc/strip_markdown.pl \
+	$(HT2LIB_PKG_SRC) \
 	Makefile \
+	CMakeLists.txt \
 	$(GENERAL_LIST)
 
 BIN_PKG_LIST = $(GENERAL_LIST)
@@ -234,6 +283,10 @@
 both: hisat2-align-s hisat2-align-l hisat2-build-s hisat2-build-l
 
 both-debug: hisat2-align-s-debug hisat2-align-l-debug hisat2-build-s-debug hisat2-build-l-debug
+
+repeat: hisat2-repeat
+
+repeat-debug: hisat2-repeat-debug
 
 DEFS=-fno-strict-aliasing \
      -DHISAT2_VERSION="\"`cat VERSION`\"" \
@@ -266,6 +319,26 @@
 	$(SHARED_CPPS) $(HISAT_CPPS_MAIN) \
 	$(LIBS) $(SEARCH_LIBS)
 
+#
+# hisat2-repeat targets
+#
+
+hisat2-repeat: hisat2_repeat.cpp $(REPEAT_CPPS) $(SHARED_CPPS) $(HEADERS)
+	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(EXTRA_FLAGS) \
+	$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
+	$(INC) \
+	-o $@ $< \
+	$(SHARED_CPPS) $(HISAT2_REPEAT_CPPS_MAIN) \
+	$(LIBS) $(BUILD_LIBS)
+
+hisat2-repeat-debug: hisat2_repeat.cpp $(REPEAT_CPPS) $(SHARED_CPPS) $(HEADERS)
+	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(EXTRA_FLAGS) \
+	$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
+	$(INC) \
+	-o $@ $< \
+	$(SHARED_CPPS) $(HISAT2_REPEAT_CPPS_MAIN) \
+	$(LIBS) $(BUILD_LIBS)
+
 
 #
 # hisat2-build targets
@@ -381,72 +454,9 @@
 	$(SHARED_CPPS) \
 	$(LIBS) $(INSPECT_LIBS)
 
-
-
-hisat2: ;
-
-hisat2.bat:
-	echo "@echo off" > hisat2.bat
-	echo "perl %~dp0/hisat2 %*" >> hisat2.bat
-
-hisat2-build.bat:
-	echo "@echo off" > hisat2-build.bat
-	echo "python %~dp0/hisat2-build %*" >> hisat2-build.bat
-
-hisat2-inspect.bat:
-	echo "@echo off" > hisat2-inspect.bat
-	echo "python %~dp0/hisat2-inspect %*" >> hisat2-inspect.bat
-
-
-.PHONY: hisat2-src
-hisat2-src: $(SRC_PKG_LIST)
-	chmod a+x scripts/*.sh scripts/*.pl
-	mkdir .src.tmp
-	mkdir .src.tmp/hisat2-$(VERSION)
-	zip tmp.zip $(SRC_PKG_LIST)
-	mv tmp.zip .src.tmp/hisat2-$(VERSION)
-	cd .src.tmp/hisat2-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
-	cd .src.tmp ; zip -r hisat2-$(VERSION)-source.zip hisat2-$(VERSION)
-	cp .src.tmp/hisat2-$(VERSION)-source.zip .
-	rm -rf .src.tmp
-
-.PHONY: hisat2-bin
-hisat2-bin: $(BIN_PKG_LIST) $(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX)
-	chmod a+x scripts/*.sh scripts/*.pl
-	rm -rf .bin.tmp
-	mkdir .bin.tmp
-	mkdir .bin.tmp/hisat2-$(VERSION)
-	if [ -f hisat2.exe ] ; then \
-		zip tmp.zip $(BIN_PKG_LIST) $(addsuffix .exe,$(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX)) ; \
-	else \
-		zip tmp.zip $(BIN_PKG_LIST) $(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX) ; \
-	fi
-	mv tmp.zip .bin.tmp/hisat2-$(VERSION)
-	cd .bin.tmp/hisat2-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
-	cd .bin.tmp ; zip -r hisat2-$(VERSION)-$(BITS).zip hisat2-$(VERSION)
-	cp .bin.tmp/hisat2-$(VERSION)-$(BITS).zip .
-	rm -rf .bin.tmp
-
-.PHONY: doc
-doc: doc/manual.inc.html MANUAL
-
-doc/manual.inc.html: MANUAL.markdown
-	pandoc -T "HISAT2 Manual" -o $@ \
-	 --from markdown --to HTML --toc $^
-	perl -i -ne \
-	 '$$w=0 if m|^</body>|;print if $$w;$$w=1 if m|^<body>|;' $@
-
-MANUAL: MANUAL.markdown
-	perl doc/strip_markdown.pl < $^ > $@
-
-.PHONY: clean
-clean:
-	rm -f $(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX) \
-	$(addsuffix .exe,$(HISAT2_BIN_LIST) $(HISAT2_BIN_LIST_AUX)) \
-	hisat2-src.zip hisat2-bin.zip
-	rm -f core.* .tmp.head
-	rm -rf *.dSYM
-
-.PHONY: push-doc
-push-doc: doc/manual.inc.html
-	scp doc/*.*html igm1:/data1/igm3/www/ccb.jhu.edu/html/software/hisat2/
+#
+# HT2LIB targets
+#
+
+ht2lib: libhisat2lib-debug.a libhisat2lib.a libhisat2lib-debug.so libhisat2lib.so
+
