=== debian/changelog ===
hisat2 (2.2.0-2) unstable; urgency=medium

  * Fix simde patch for ppc64el
  * Fix missing $(LDFLAGS) in hardening patch

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 06 May 2020 20:48:11 +0200

hisat2 (2.2.0-1) unstable; urgency=medium

  * Use the libsimde-dev package instead of our code copy.
  * Standards-Version: 4.5.0 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Upstream moved to GitHub
  * Use the HISAT2 citation instead of the HISAT paper
  * New upstream version
  * Freshen the patches
  * Added patch to fix the manual path

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sun, 19 Apr 2020 23:04:26 +0200

hisat2 (2.1.0-4) unstable; urgency=medium

  * Integrate recent changes with the new python3-hisat2 package.
  * Made it easier to cross build the package

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 11 Feb 2020 18:22:17 +0100
