=== debian/control ===
Source: hisat2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               libsimde-dev,
               help2man <!nodoc>,
               pandoc <!nodoc>,
               python3:any <!nodoc>
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/hisat2
Vcs-Git: https://salsa.debian.org/med-team/hisat2.git
Homepage: https://daehwankimlab.github.io/hisat2/
Rules-Requires-Root: no

Package: hisat2
Architecture: any
Built-Using: ${simde:Built-Using}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${perl:Depends},
         python3
Recommends: python3-hisat2,
            bcftools,
            samtools
Description: graph-based alignment of short nucleotide reads to many genomes
 HISAT2 is a fast and sensitive alignment program for mapping next-generation
 sequencing reads (both DNA and RNA) to a population of human genomes (as well
 as against a single reference genome). Based on an extension of BWT for graphs
 a graph FM index (GFM) was designed and implementd. In addition to using
 one global GFM index that represents a population of human genomes, HISAT2
 uses a large set of small GFM indexes that collectively cover the whole genome
 (each index representing a genomic region of 56 Kbp, with 55,000 indexes
 needed to cover the human population). These small indexes (called local
 indexes), combined with several alignment strategies, enable rapid and
 accurate alignment of sequencing reads. This new indexing scheme is called a
 Hierarchical Graph FM index (HGFM).

Package: python3-hisat2
Section: python
Architecture: all
Built-Using: ${simde:Built-Using}
Depends: ${misc:Depends},
         hisat2,
         python3
Description: Python scripts accompanying hisat2
 HISAT2 is a fast and sensitive alignment program for mapping next-
 generation sequencing reads (both DNA and RNA) to a population of human
 genomes (as well as against a single reference genome). Based on an
 extension of BWT for graphs a graph FM index (GFM) was designed and
 implementd. In addition to using one global GFM index that represents a
 population of human genomes, HISAT2 uses a large set of small GFM
 indexes that collectively cover the whole genome (each index
 representing a genomic region of 56 Kbp, with 55,000 indexes needed to
 cover the human population). These small indexes (called local indexes),
 combined with several alignment strategies, enable rapid and accurate
 alignment of sequencing reads. This new indexing scheme is called a
 Hierarchical Graph FM index (HGFM).
 .
 This package provides a serires of platform-independent scripts that are
 typically expected to be co-installed with the hisat2 binary.
