=== debian/tests/control ===
Tests: run-unit-tests
Depends: @, samtools, bcftools
Restrictions: allow-stderr
