=== Makefile ===
--- 
+++ 
@@ -237,8 +237,6 @@
 GENERAL_LIST = $(wildcard scripts/*.sh) \
 	$(wildcard scripts/*.pl) \
 	$(wildcard *.py) \
-	$(wildcard hisatgenotype_modules/*.py) \
-	$(wildcard hisatgenotype_scripts/*.py) \
 	$(wildcard example/index/*.ht2) \
 	$(wildcard example/reads/*.fa) \
 	example/reference/22_20-21M.fa \
@@ -460,3 +458,6 @@
 
 ht2lib: libhisat2lib-debug.a libhisat2lib.a libhisat2lib-debug.so libhisat2lib.so
 
+libhisat2lib-debug.a: $(HT2LIB_DEBUG_OBJS)
+	ar rc $@ $(HT2LIB_DEBUG_OBJS) 
+
