=== debian/changelog ===
hisat2 (2.2.1-4) unstable; urgency=medium

  * Team upload
  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)
  * Update lintian-overrides

 -- Andreas Tille <tille@debian.org>  Fri, 14 Oct 2022 20:18:28 +0200

hisat2 (2.2.1-3) unstable; urgency=medium

  * Team upload.
  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0 (routine-update)
  * Fix debian/source/lintian-overrides

 -- Andreas Tille <tille@debian.org>  Tue, 28 Sep 2021 10:35:43 +0200

hisat2 (2.2.1-2) unstable; urgency=medium

  * debian/patches/riscv5: fix compilation on riscv5
  * Standards-Version: 4.5.1 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 27 Jan 2021 17:34:32 +0100

hisat2 (2.2.1-1) unstable; urgency=medium

  [ Steffen Moeller ]
  * Team upload.
  * New upstream version
  * debhelper-compat 13 (routine-update)

  [ Michael R. Crusoe ]
  * Refresh the patches

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 11 Aug 2020 13:42:31 +0200
